<template>
  <!--首页流程处理的组件-->
  <div>
    <mt-header class="home-header" >
      <router-link to="/" slot="left">
        <span class="title">{{systemData.systemData.name}}</span>
      </router-link>
      <router-link to="/mainCarboncopy" slot="right">
        <mt-button>
          <span class="join">{{$t('showMore')}}</span>
          <div class="more-arrow"></div>
        </mt-button>
      </router-link>
    </mt-header>
    <mt-navbar v-model="selected">
      <mt-tab-item id="tab_pending" @click="Partialrefresh">{{$t('toberead')}}<span>({{row_count}})</span></mt-tab-item>
      <mt-tab-item id="tab_done" @click="Partialrefresh">{{$t('read')}}</mt-tab-item>
    </mt-navbar>
    <!-- tab-container -->
    <mt-tab-container v-model="selected">
      <mt-tab-container-item id="tab_pending">
        <mt-loadmore
          :top-method="loadTop"
          ref="loadmorepending"
        >
          <div class="cell-body" v-for="(pending,index) in pendingList" :key="index">
            <router-link :to="{name:'open', query:{linkType:'00',actionContent:pending.formId,docId:pending.docId}}">
            <div class="flow-title">
              <div class="cell-photo" v-if="pending.photo">
                <img :src="pending.photo" />
              </div>
              <div class="cell-avatar" v-else>
                
              </div>
              <span class="cell-title">
                {{pending.flowName}}
                <span v-html="pending.summary"></span>
              </span>
            </div>
            <div class="footer">
              <div class="cell-info">
                <span>{{pending.initiator}}</span> 
              </div>
              <div class="cell-date">
                <span>{{pending.lastProcessTime}}</span>
              </div>
            </div>
            </router-link>
          </div>
          <div class="see-more" v-if="pendingList.length>0">
            <router-link to="/flowcenter" class="router-link">
              <span>
                {{$t('showMore')}}
              </span>
              <span class="fa-icon">
                <i class="fa fa-arrow-right color"></i> 
              </span>  
            </router-link>
          </div>
          <div class="home-flow" v-if="pendingList.length<1 && showPending">
            <div class="view-nodata" >
              <div class="view-nodata-img">
                <i class="fa fa-inbox fa-5x"></i>
              </div>
              <div class="view-nodata-text">{{$t('noData')}}</div>
            </div>
          </div>
        </mt-loadmore>
      </mt-tab-container-item>
      <mt-tab-container-item id="tab_done">
        <div class="cell-body" v-for="(processed,index) in processedList" :key="index">
          <router-link :to="{name:'open', query:{linkType:'00',actionContent:processed.formId,docId:processed.docId}}">
          <div class="flow-title">
            <div class="cell-photo" v-if="processed.photo">
              <img :src="processed.photo" />
            </div>

            <div class="cell-avatar" v-else></div>

            <span class="cell-title">
              {{processed.flowName}}
              <span v-html="processed.summary"></span>
            </span>
          </div>
          <div class="footer">
            <div class="cell-info">
              <span>{{processed.initiator}}</span> 
              <!-- <span class="deptName">{{processed.initiatorDept}}</span> -->
            </div>
            <div class="cell-date">
              <span>{{processed.lastProcessTime}}</span>
            </div>
          </div>
          </router-link>
        </div>
        <div class="see-more"  v-if="processedList.length>0">
          <router-link to="/flowcenter" class="router-link">
            <span>
              {{$t('showMore')}}
            </span>
            <span class="fa-icon">
              <i class="fa fa-arrow-right color"></i> 
            </span>  
          </router-link>
        </div>
        <div class="home-flow" v-if="processedList.length<1 && showProcessed">
          <div class="view-nodata" >
            <div class="view-nodata-img">
              <i class="fa fa-inbox fa-5x"></i>
            </div>
            <div class="view-nodata-text">{{$t('noData')}}</div>
          </div>
        </div>
      </mt-tab-container-item>
    </mt-tab-container>
  </div>
</template>

<script>
import API from "@/api.js";

//import axios from "axios";
export default {
  inject: ["reload"],
  props: [
    "systemData"
  ],
  created() {
    let appId = this.$root.appid;
    let params = {
        title: '',
        linesPerPage: 5,
        pageNo: 1,
        initiatorId: '',
        flowId: '',
        isRead: false,
        isMyWorkFlow: false,
        appId: this.$root.appid,
        _: new Date().getTime(),
      }
    this.$api.getCarboncopyList(
      appId,
      params,
      {
        onSucess: res => {
          this.row_count = res.data.data.rowCount;
          this.showPending = true;
          let newData = res.data.data.datas.map(item => {
            return {
              formId: item.formId,
              docId: item.docId,
              initiator: item.initiator,
              initiatorDept: item.initiatorDept,
              lastProcessTime:  this.writeCurrentDate(item.lastProcessTime),//dateFormat.calculateTime(this.writeCurrentDate(item.lastProcessTime)),//this.writeCurrentDate(item.lastProcessTime), //.substring(5, 10),
              lastFlowOperation: (item.lastFlowOperation = "流转"),
              stateLabel: item.stateLabel,
              subject: item.subject,
              read:item.read,
              formName: item.formName,
              flowName: item.flowName,
            };
          });
          this.pendingList = newData;
        }
      }
    )
    this.finished();
  },
  data: function() {
    return {
      selected: "tab_pending",
      rowCount: "",
      pendingList: [],
      processedList: [],
      conceal: false,
      dispose: true, //控制流程处理隐藏或这显示
      GonnaSelect: "pending",
      showPending:false,
      showProcessed:false,
      system_workflow:'',
      row_count:0,
    };
  },
  methods: {
    writeCurrentDate(val){
      let now = new Date(val);
      let year=now.getFullYear(); 
      let month=now.getMonth()+1; 
      let date=now.getDate(); 
      let hour=now.getHours(); 
      let minute=now.getMinutes(); 
      let second=now.getSeconds(); 
      return year+"-"+month+"-"+date+" "+hour+":"+minute+":"+second; 
    },

    loadTop() {
      API.getPendingList(this.$root.appid, { pageNo: 1, linesPerPage: 5 },
        {
          onSucess: response => {
            this.pendingList = response.data.data.datas;
            this.showPending = true;
            this.rowCount = response.data.data.rowCount;
            this.$refs.loadmorepending.onTopLoaded();
            for(let i=0; i<this.pendingList.length; i++) {
              this.$api.getAvatar(this.pendingList[i].initiatorId, {
                onSucess: response => {
                  this.pendingList[i].photo =  response.data.data;
                  this.$forceUpdate();
                }
              })
            }
          }
        }
      );
    },

    finished() {
      let appId = this.$root.appid;
      let params = {
          title: '',
          linesPerPage: 5,
          pageNo: 1,
          initiatorId: '',
          flowId: '',
          isRead: true,
          isMyWorkFlow: false,
          appId: this.$root.appid,
          _: new Date().getTime(),
        }
      this.$api.getCarboncopyList(
        appId,
        params,
        {
          onSucess: res => {
            // this.row_count = res.data.data.rowCount;
            let newData = res.data.data.datas.map(item => {
              return {
                formId: item.formId,
                docId: item.docId,
                initiator: item.initiator,
                initiatorDept: item.initiatorDept,
                lastProcessTime: this.writeCurrentDate(item.lastProcessTime),//dateFormat.calculateTime(this.writeCurrentDate(item.lastProcessTime)), //.substring(5, 10),
                lastFlowOperation: (item.lastFlowOperation = "流转"),
                stateLabel: item.stateLabel,
                subject: item.subject,
                read:item.read,
                formName: item.formName,
                flowName: item.flowName,
              };
            });
            this.processedList = newData;
          }
        }
      )



    },
    //流程处理的局部刷新
    Partialrefresh() {
      this.reload();
    }
  },
  filters: {
    formatDate: function (value) {// 时间戳转换日期格式方法
        if (value == null) {
            return '';
        } else {
            let date = new Date(value);
            let y = date.getFullYear();// 年
            let MM = date.getMonth() + 1;// 月
            MM = MM < 10 ? ('0' + MM) : MM;
            let d = date.getDate();// 日
            d = d < 10 ? ('0' + d) : d;
            let h = date.getHours();// 时
            h = h < 10 ? ('0' + h) : h;
            let m = date.getMinutes();// 分
            m = m < 10 ? ('0' + m) : m;
            let s = date.getSeconds();// 秒
            s = s < 10 ? ('0' + s) : s;
            return y + '-' + MM + '-' + d + ' ' + h + ':' + m + ':' + s;
        }
    }
  }
};
</script>
